// get Item_Key first so we can make changes
forceRequiredAddOn("Item_Key");

if($Pref::KeyNames_Legacy $= ""){$Pref::KeyNames_Legacy = true;}
if($Pref::KeyNames_New $= ""){$Pref::KeyNames_New = true;}
if($Pref::KeyNames_UseCards $= ""){$Pref::KeyNames_UseCards = false;}


if($Pref::KeyNames_UseCards)
{
	redKeyItem.shapeFile = "./card.dts";
	redKeyImage.shapeFile = "./card.dts";
	yellowKeyItem.shapeFile = "./card.dts";
	yellowKeyImage.shapeFile = "./card.dts";
	blueKeyItem.shapeFile = "./card.dts";
	blueKeyImage.shapeFile = "./card.dts";
	greenKeyItem.shapeFile = "./card.dts";
	greenKeyImage.shapeFile = "./card.dts";
	
	redKeyItem.iconName = "./icon_card1";
	yellowKeyItem.iconName = "./icon_card1";
	blueKeyItem.iconName = "./icon_card1";
	greenKeyItem.iconName = "./icon_card1";
}

function redKeyImage::onPreFire(%this, %obj, %slot)
{
	if($Pref::KeyNames_UseCards)
		%obj.playthread(2, plant);
	else
		%obj.playthread(2, shiftLeft);
}

//// New keys
// Orange Key
datablock ItemData(orangeKeyItem : yellowKeyItem)
{
   uiName = "Key Orange";
   colorShiftColor = "1.0 0.4 0.0 1.0";
   image = orangeKeyImage;
};
datablock ShapeBaseImageData(orangeKeyImage : yellowKeyImage)
{
   colorShiftColor = orangeKeyItem.colorShiftColor;
};
function orangeKeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}
function orangeKeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}
function orangeKeyImage::onFire(%this, %player, %slot)
{
   redKeyImage::onFire(%this, %player, %slot);
}
// Purple Key
datablock ItemData(purpleKeyItem : redKeyItem)
{
   uiName = "Key Purple";
   colorShiftColor = "0.7 0.0 1.0 1.0";
   image = purpleKeyImage;
};
datablock ShapeBaseImageData(purpleKeyImage : redKeyImage)
{
   colorShiftColor = purpleKeyItem.colorShiftColor;
};
function purpleKeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}
function purpleKeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}
function purpleKeyImage::onFire(%this, %player, %slot)
{
   redKeyImage::onFire(%this, %player, %slot);
}
// Cyan Key
datablock ItemData(cyanKeyItem : blueKeyItem)
{
   uiName = "Key Cyan";
   colorShiftColor = "0.0 1.0 1.0 1.0";
   image = cyanKeyImage;
};
datablock ShapeBaseImageData(cyanKeyImage : blueKeyImage)
{
   colorShiftColor = cyanKeyItem.colorShiftColor;
};
function cyanKeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}
function cyanKeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}
function cyanKeyImage::onFire(%this, %player, %slot)
{
   redKeyImage::onFire(%this, %player, %slot);
}
// Lime Key
datablock ItemData(limeKeyItem : greenKeyItem)
{
   uiName = "Key Lime";
   colorShiftColor = "0.75 1.0 0.25 1.0";
   image = limeKeyImage;
};
datablock ShapeBaseImageData(limeKeyImage : greenKeyImage)
{
   colorShiftColor = limeKeyItem.colorShiftColor;
};
function limeKeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}
function limeKeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}
function limeKeyImage::onFire(%this, %player, %slot)
{
   redKeyImage::onFire(%this, %player, %slot);
}
// Grey Keys
datablock ItemData(Grey1KeyItem : redKeyItem)
{
   uiName = "Key 1";
   colorShiftColor = "0.4 0.4 0.4 1.0";
   image = Grey1KeyImage;
};
datablock ShapeBaseImageData(Grey1KeyImage : redKeyImage)
{
   colorShiftColor = Grey1KeyItem.colorShiftColor;
};
function Grey1KeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}
function Grey1KeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}
function Grey1KeyImage::onFire(%this, %player, %slot)
{
   redKeyImage::onFire(%this, %player, %slot);
}
datablock ItemData(Grey2KeyItem : yellowKeyItem)
{
   uiName = "Key 2";
   colorShiftColor = "0.4 0.4 0.4 1.0";
   image = Grey2KeyImage;
};
datablock ShapeBaseImageData(Grey2KeyImage : yellowKeyImage)
{
   colorShiftColor = Grey2KeyItem.colorShiftColor;
};
function Grey2KeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}
function Grey2KeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}
function Grey2KeyImage::onFire(%this, %player, %slot)
{
   redKeyImage::onFire(%this, %player, %slot);
}
datablock ItemData(Grey3KeyItem : greenKeyItem)
{
   uiName = "Key 3";
   colorShiftColor = "0.4 0.4 0.4 1.0";
   image = Grey3KeyImage;
};
datablock ShapeBaseImageData(Grey3KeyImage : greenKeyImage)
{
   colorShiftColor = Grey3KeyItem.colorShiftColor;
};
function Grey3KeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}
function Grey3KeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}
function Grey3KeyImage::onFire(%this, %player, %slot)
{
   redKeyImage::onFire(%this, %player, %slot);
}
datablock ItemData(Grey4KeyItem : blueKeyItem)
{
   uiName = "Key 4";
   colorShiftColor = "0.4 0.4 0.4 1.0";
   image = Grey4KeyImage;
};
datablock ShapeBaseImageData(Grey4KeyImage : blueKeyImage)
{
   colorShiftColor = Grey4KeyItem.colorShiftColor;
};
function Grey4KeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}
function Grey4KeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}
function Grey4KeyImage::onFire(%this, %player, %slot)
{
   redKeyImage::onFire(%this, %player, %slot);
}
// Skeleton Key
datablock ItemData(SkeletonKeyItem : yellowKeyItem)
{
   shapeFile = "./skele_key.dts";
   uiName = "Key Skeleton";
   iconName = "./icon_skeleton";
   colorShiftColor = "0.2 0.2 0.2 1.0";
   image = SkeletonKeyImage;
};
datablock ShapeBaseImageData(SkeletonKeyImage : yellowKeyImage)
{
   shapeFile = "./skele_key.dts";
   colorShiftColor = SkeletonKeyItem.colorShiftColor;
};
function SkeletonKeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}
function SkeletonKeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}
function SkeletonKeyImage::onFire(%this, %player, %slot)
{
   redKeyImage::onFire(%this, %player, %slot);
}
// Personal Key
datablock ItemData(PersonalKeyItem : redKeyItem)
{
   uiName = "Key Personal";
   colorShiftColor = "0.528 0.528 0.374 1.0";
   image = PersonalKeyImage;
};
datablock ShapeBaseImageData(PersonalKeyImage : redKeyImage)
{
   colorShiftColor = PersonalKeyItem.colorShiftColor;
};
function PersonalKeyImage::onPreFire(%this, %obj, %slot)
{
	redKeyImage::onPreFire(%this, %obj, %slot);
}
function PersonalKeyImage::onStopFire(%this, %obj, %slot)
{	
	redKeyImage::onStopFire(%this, %obj, %slot);
}
function PersonalKeyImage::onFire(%this, %player, %slot)
{
   redKeyImage::onFire(%this, %player, %slot);
}

if($Pref::KeyNames_UseCards)
{
	Grey1KeyItem.shapeFile = "./card1.dts";
	Grey1KeyImage.shapeFile = "./card1.dts";
	Grey2KeyItem.shapeFile = "./card2.dts";
	Grey2KeyImage.shapeFile = "./card2.dts";
	Grey3KeyItem.shapeFile = "./card3.dts";
	Grey3KeyImage.shapeFile = "./card3.dts";
	Grey4KeyItem.shapeFile = "./card4.dts";
	Grey4KeyImage.shapeFile = "./card4.dts";
	SkeletonKeyItem.shapeFile = "./card5.dts";
	SkeletonKeyImage.shapeFile = "./card5.dts";
	SkeletonKeyItem.uiName = "Key Master";
	SkeletonKeyItem.iconName = "./icon_card1";
	SkeletonKeyItem.colorShiftColor = "0.25 0.6 0.9 1.0";
	SkeletonKeyImage.colorShiftColor = "0.25 0.6 0.9 1.0"; 
}


// Re-direct functions to a new function
function redKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "r");
}

function yellowKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "y");
}

function blueKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "b");
}

function greenKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "g");
}

function orangeKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "o");
}

function limeKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "l");
}

function purpleKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "p");
}

function cyanKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "c");
}

function Grey1KeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "1");
}

function Grey2KeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "2");
}

function Grey3KeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "3");
}

function Grey4KeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handleKeyFunc(%player, %hitObj, "4");
}

function SkeletonKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	%hitObj.onKeyMatch(%player);
}

function PersonalKeyImage::onHitObject(%this, %player, %slot, %hitObj, %hitPos, %hitNormal)
{
	handlePersonalKey(%player, %hitObj);
}

function handleKeyFunc(%player, %brick, %color)
{
	if(%color $= "" || !isObject(%brick) || !isObject(%player))
		return;
		
	if(!$Pref::KeyNames_Legacy && !$Pref::KeyNames_New)
		$Pref::KeyNames_New = true;
		
	%brickname = %brick.getName();
	
	%fields = strReplace(%brickname, "_", "" TAB "");
	%fieldCount = getFieldCount(%fields);
	
	%hasCorrectKey = false;
	
	if($Pref::KeyNames_Legacy)
	{
		for(%i = 0; %i < %fieldCount; %i++)
		{
			%field = strlwr(getField(%fields, %i));
			%keyId = getSubStr(%field, 0, 4);
			if(%keyId $= "rkey")
			{
				%colorFound = getSubStr(%field, 4, 1);
			}
			
			if(%colorFound $= %color)
			{
				%hasCorrectKey = true;
				break;
			}
		}
	}
	
	if($Pref::KeyNames_New)
	{
		for(%i = 0; %i < %fieldCount; %i++)
		{
			%field = strlwr(getField(%fields, %i));
			%keyId = getSubStr(%field, 0, 3);
			if(%keyId $= "key")
			{
				%keyString = strReplace(strChr(%field, "key"), "key", "");
				%keyLen = strLen(%keyString);
				
				for(%a = 0; %a < %keyLen; %a++)
				{
					%char = getSubStr(%keyString, %a, 1);
					if(%char $= %color)
					{
						%hasCorrectKey = true;
						break;
					}
				}
			}
			
			if(%hasCorrectKey)
				break;
		}
	}
	
	if(!%hasCorrectKey)
	{
		%brick.onKeyMismatch(%player);
	}
	else
	{
		%brick.onKeyMatch(%player);
	}
}

function handlePersonalKey(%player, %brick)
{
	%trust = getTrustLevel(%player, %brick);
	
	if(!%trust)
	{
		%brick.onKeyMismatch(%player);
		%player.client.sendTrustFailureMessage(%brick.getGroup());
	}
	else
	{
		%brickname = %brick.getName();
		%fields = strReplace(%brickname, "_", "" TAB "");
		%fieldCount = getFieldCount(%fields);
	
		for(%i = 0; %i < %fieldCount; %i++)
		{
			%field = strlwr(getField(%fields, %i));
			%keyId = getSubStr(%field, 0, 4);
			if(%keyId $= "pkey")
			{
				%brick.onKeyMatch(%player);
			}
		}
	}
}